% Cherchye, De Rock, Lewbel and Vermeulen - Sharing rule identification.
% This programme estimates QUAIDS-quantities for a given full income and given prices.
% 08/10/2014

function qa=QUAIDSSR1Children(pa,ya)

global nn

const=1;

lx=log(ya);

p1=pa(1);
p2=pa(2);
p3=pa(3);
p4=pa(4);
p5=pa(5);

lp1=log(p1);
lp2=log(p2);
lp3=log(p3);
lp4=log(p4);
lp5=log(p5);

rlp1=lp1-lp5;
rlp2=lp2-lp5;
rlp3=lp3-lp5;
rlp4=lp4-lp5;

rp1=p1./p5;
rp2=p2./p5;
rp3=p3./p5;
rp4=p4./p5;

load bquaidsSR1Children.out
bquaids=bquaidsSR1Children;
nq=length(bquaids);
kq=nq/(nn-1);

b1=bquaids(1:kq);
b2=bquaids(kq+1:2*kq);
b3=bquaids(2*kq+1:3*kq);
b4=bquaids(3*kq+1:4*kq);

  a1=b1(1);
  a2=b2(1);
  a3=b3(1);
  a4=b4(1);
  
  g11=b1(kq-3);
  g12=b1(kq-2);
  g13=b1(kq-1);
  g14=b1(kq);
  g15=-(g11+g12+g13+g14);

  g21=b2(kq-3);
  g22=b2(kq-2);
  g23=b2(kq-1);
  g24=b2(kq);
  g25=-(g21+g22+g23+g24);

  g31=b3(kq-3);
  g32=b3(kq-2);
  g33=b3(kq-1);
  g34=b3(kq);
  g35=-(g31+g32+g33+g34);

  g41=b4(kq-3);
  g42=b4(kq-2);
  g43=b4(kq-1);
  g44=b4(kq);
  g45=-(g41+g42+g43+g44);

  g51=-(g11+g21+g31+g41);
  g52=-(g12+g22+g32+g42);
  g53=-(g13+g23+g33+g43);
  g54=-(g14+g24+g34+g44);
  g55=-(g15+g25+g35+g45);
      
  logap=g11.*rlp1.*rlp1+g12.*rlp1.*rlp2+g13.*rlp1.*rlp3+g14.*rlp1.*rlp4;
  logap=logap+g21.*rlp2.*rlp1+g22.*rlp2.*rlp2+g23.*rlp2.*rlp3+g24.*rlp2.*rlp4;
  logap=logap+g31.*rlp3.*rlp1+g32.*rlp3.*rlp2+g33.*rlp3.*rlp3+g34.*rlp3.*rlp4;
  logap=logap+g41.*rlp4.*rlp1+g42.*rlp4.*rlp2+g43.*rlp4.*rlp3+g44.*rlp4.*rlp4;
  logap=0.5*logap;
  logap=logap+a1.*rlp1+a2.*rlp2+a3.*rlp3+a4.*rlp4+2*const+lp5;
  
  bp=(rp1.^b1(2)).*(rp2.^b2(2)).*(rp3.^b3(2)).*(rp4.^b4(2));

rlx=lx-logap;
rlx2=rlx.^2;

X=[1 rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];

ew1=X*b1;
ew2=X*b2;
ew3=X*b3;
ew4=X*b4;
ew5=1-ew1-ew2-ew3-ew4;

ew=[ew1;ew2;ew3;ew4;ew5];

qa=zeros(nn,1);

for i=1:nn
   qa(i)=ew(i)*ya/pa(i); 
end