% Cherchye, De Rock, Lewbel and Vermeulen - Sharing rule identification.
% This programme reads data from PSID and estimates a QUAIDS by means of MM while imposing SR1.
% 07/10/2014

clc

global w1 w2 w3 w4 const lx rlp1 rlp2 rlp3 rlp4 rp1 rp2 rp3 rp4 lp5 AgeHusband AgeWife Homeowner

tic

load PSIDWave19992009NoChildren.txt
PSIDWave19992009Complete5goods=PSIDWave19992009NoChildren;

InterviewNr1999=PSIDWave19992009Complete5goods(:,1);
Year=PSIDWave19992009Complete5goods(:,2);
AgeHusband=PSIDWave19992009Complete5goods(:,3); 
AgeWife=PSIDWave19992009Complete5goods(:,4); 
ChildrenNumber=PSIDWave19992009Complete5goods(:,5); 
Region=PSIDWave19992009Complete5goods(:,6); 
GradeEducationHusband=PSIDWave19992009Complete5goods(:,7); 
GradeEducationWife=PSIDWave19992009Complete5goods(:,8); 
FullIncome=PSIDWave19992009Complete5goods(:,9); 
LeisureHusband=PSIDWave19992009Complete5goods(:,10); 
LeisureWife=PSIDWave19992009Complete5goods(:,11); 
WageRateHusband=PSIDWave19992009Complete5goods(:,12); 
WageRateWife=PSIDWave19992009Complete5goods(:,13); 

QuantFood=PSIDWave19992009Complete5goods(:,14); 
QuantHousing=PSIDWave19992009Complete5goods(:,15); 
QuantOther=PSIDWave19992009Complete5goods(:,16); 

PriceFood=PSIDWave19992009Complete5goods(:,17); 
PriceHousing=PSIDWave19992009Complete5goods(:,18); 
PriceOther=PSIDWave19992009Complete5goods(:,19); 

Homeowner=PSIDWave19992009Complete5goods(:,20); 

w1=(WageRateHusband.*LeisureHusband)./FullIncome;
w2=(WageRateWife.*LeisureWife)./FullIncome;
w3=(PriceFood.*QuantFood)./FullIncome;
w4=(PriceHousing.*QuantHousing)./FullIncome;
w5=(PriceOther.*QuantOther)./FullIncome;

lx=log(FullIncome);

p1=WageRateHusband;
p2=WageRateWife;
p3=PriceFood;
p4=PriceHousing;
p5=PriceOther;

lp1=log(WageRateHusband);
lp2=log(WageRateWife);
lp3=log(PriceFood);
lp4=log(PriceHousing);
lp5=log(PriceOther);

rlp1=lp1-lp5;
rlp2=lp2-lp5;
rlp3=lp3-lp5;
rlp4=lp4-lp5;

rp1=p1./p5;
rp2=p2./p5;
rp3=p3./p5;
rp4=p4./p5;

n=length(w1);
const=ones(n,1);

%%

load bquaidsstoneEcma2TasteShifters2NoChildren.out
x0=bquaidsstoneEcma2TasteShifters2NoChildren;

options = optimset('Algorithm','Interior-point','Display','iter','Maxiter',50000,'MaxFunEval',50000);
% Minimization
[x,fval,exitflag]=fmincon(@funcQUAIDSSR1_Ecma2_TasteShifters2,x0,[ ], [ ], [ ], [ ],[ ],[ ],@consQUAIDSNoSR1_Ecma2_TasteShifters2,options)

%%
save bquaidsNOSR1TasteShifters2NoChildren.out x -ASCII

ngood=4;
nobs=length(w1);

logap=x(6).*rlp1.*rlp1+x(7).*rlp1.*rlp2+x(8).*rlp1.*rlp3+x(9).*rlp1.*rlp4;
logap=logap+x(15).*rlp2.*rlp1+x(16).*rlp2.*rlp2+x(17).*rlp2.*rlp3+x(18).*rlp2.*rlp4;
logap=logap+x(24).*rlp3.*rlp1+x(25).*rlp3.*rlp2+x(26).*rlp3.*rlp3+x(27).*rlp3.*rlp4;
logap=logap+x(33).*rlp4.*rlp1+x(34).*rlp4.*rlp2+x(35).*rlp4.*rlp3+x(36).*rlp4.*rlp4;
logap=0.5*logap;
logap=logap+x(1).*rlp1+x(10).*rlp2+x(19).*rlp3+x(28).*rlp4+2*const+lp5;

bp=(rp1.^x(4)).*(rp2.^x(13)).*(rp3.^x(22)).*(rp4.^x(31));

rlx=lx-logap;
rlx2=rlx.^2;

X=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];

b=zeros(9,ngood);
nr=0;
for i=1:ngood
   for j=1:9
      nr=nr+1;
      b(j,i)=x(nr); 
   end
end

ew=zeros(nobs,ngood+1);

for i=1:ngood
    ew(:,i)=X*b(:,i);
end

ew(:,ngood+1)=const-ew(:,1)-ew(:,2)-ew(:,3)-ew(:,4);

Compare=[w1 ew(:,1) w2 ew(:,2) w3 ew(:,3) w4 ew(:,4) w5 ew(:,5)]
mean(Compare)
toc
totalruntime=toc/60