% Cherchye, De Rock, Lewbel and Vermeulen - Sharing rule identification.
% This programme reads data from PSID and estimates a QUAIDS with Stone index.
% Taste shifters age and homeownership.
% Multicollinearity: only age husbands

clc

tic

load PSIDWave19992009NoChildren.txt
PSIDWave19992009Complete5goods=PSIDWave19992009NoChildren;

InterviewNr1999=PSIDWave19992009Complete5goods(:,1);
Year=PSIDWave19992009Complete5goods(:,2);
AgeHusband=PSIDWave19992009Complete5goods(:,3); 
AgeWife=PSIDWave19992009Complete5goods(:,4); 
ChildrenNumber=PSIDWave19992009Complete5goods(:,5); 
Region=PSIDWave19992009Complete5goods(:,6); 
GradeEducationHusband=PSIDWave19992009Complete5goods(:,7); 
GradeEducationWife=PSIDWave19992009Complete5goods(:,8); 
FullIncome=PSIDWave19992009Complete5goods(:,9); 
LeisureHusband=PSIDWave19992009Complete5goods(:,10); 
LeisureWife=PSIDWave19992009Complete5goods(:,11); 
WageRateHusband=PSIDWave19992009Complete5goods(:,12); 
WageRateWife=PSIDWave19992009Complete5goods(:,13); 

QuantFood=PSIDWave19992009Complete5goods(:,14); 
QuantHousing=PSIDWave19992009Complete5goods(:,15); 
QuantOther=PSIDWave19992009Complete5goods(:,16); 

PriceFood=PSIDWave19992009Complete5goods(:,17); 
PriceHousing=PSIDWave19992009Complete5goods(:,18); 
PriceOther=PSIDWave19992009Complete5goods(:,19); 

Homeowner=PSIDWave19992009Complete5goods(:,20);

w1=(WageRateHusband.*LeisureHusband)./FullIncome;
w2=(WageRateWife.*LeisureWife)./FullIncome;
w3=(PriceFood.*QuantFood)./FullIncome;
w4=(PriceHousing.*QuantHousing)./FullIncome;
w5=(PriceOther.*QuantOther)./FullIncome;

lx=log(FullIncome);

p1=WageRateHusband;
p2=WageRateWife;
p3=PriceFood;
p4=PriceHousing;
p5=PriceOther;

lp1=log(WageRateHusband);
lp2=log(WageRateWife);
lp3=log(PriceFood);
lp4=log(PriceHousing);
lp5=log(PriceOther);

rlp1=lp1-lp5;
rlp2=lp2-lp5;
rlp3=lp3-lp5;
rlp4=lp4-lp5;

rp1=p1./p5;
rp2=p2./p5;
rp3=p3./p5;
rp4=p4./p5;

n=length(w1);
const=ones(n,1);

logap=mean(w1)*lp1+mean(w2)*lp2+mean(w3)*lp3+mean(w4)*lp4+mean(w5)*lp5;
bp=1;
rlx=lx-logap;
rlx2=rlx.^2;
x1=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];
x2=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];
x3=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];
x4=[const AgeHusband Homeowner rlx rlx2./bp rlp1 rlp2 rlp3 rlp4];
      
[n k]=size(x1);
  
b1=(x1'*x1)\(x1'*w1);
b2=(x2'*x2)\(x2'*w2);
b3=(x3'*x3)\(x3'*w3);
b4=(x4'*x4)\(x4'*w4);
    
b=[b1 ; b2 ; b3 ; b4];

save bquaidsstoneEcma2TasteShifters2NoChildren.out b -ASCII

MeanBS=[mean(w1) mean(w2) mean(w3) mean(w4) mean(w5)];
save MeanBSEcma2TasteShifters2NoChildren.out MeanBS -ASCII

ew1=x1*b1;
ew2=x2*b2;
ew3=x3*b3;
ew4=x4*b4;
ew5=1-ew1-ew2-ew3-ew4;

Compare=[w1 ew1 w2 ew2 w3 ew3 w4 ew4 w5 ew5]
mean(Compare)
toc
totalruntime=toc/60