% 17/11/2011
% Prediction demand on the basis of a multivariate kernel (function through
% Matlab site.

function qp = functionkerneldemandDYN(X,pricekernel,incomekernel)

global demandfun

%%
nvar=size(X,2);

nn=(nvar-1)/2; % number of goods

price_eval=pricekernel'/pricekernel(nn,1);
income_eval=incomekernel/pricekernel(nn,1);

price_other=price_eval(:,nn);
price_eval=[price_eval(:,1:nn-1) income_eval];

%% quantities 1 to nn-1

for i=1:(nn-1)
qp(i) = demandfun{i}(price_eval);
end


%% quantities nn
expenditure=0;
for i=1:(nn-1)
    expenditure=expenditure+price_eval(i)*qp(i);
end
qp(nn)=(income_eval-expenditure)/price_other;

%%
qp_temp=qp(1);
for i=2:nn
    qp_temp=[qp_temp; qp(i)];
end
qp=qp_temp;