function [c, ceq] = PNPOPTPARAMconst_ass4SHrestr_tomrun(x4)

global qe pe ass excl1 excl2 X nn numbass numbexcl rows4_constraints AgeHusbande AgeWifee Homeownere


% Calculation household demand r (= 1 in paper) and s (= 2 in paper)

p1=x4(1:nn);
ex1=x4(nn+1);

p2=x4(nn+2:2*nn+1);
ex2=x4(2*nn+2);

%qr=zeros(nn,1);
qr=QUAIDSSR1TasteShifters2Children(p1,ex1,AgeHusbande,Homeownere);

%qs=zeros(nn,1);
qs=QUAIDSSR1TasteShifters2Children(p2,ex2,AgeHusbande,Homeownere);

pr=x4(1:nn);
ps=x4(nn+2:2*nn+1);

c=zeros(rows4_constraints,1);

%ceq: first 2 equality constraints for defining the upper bounds
c(1)=x4(6*nn+3)-pe'*(ass.*x4(2*nn+3:3*nn+2)+(ones(nn,1)-ass).*qr);
c(2)=x4(6*nn+4)-pe'*(ass.*x4(5*nn+3:6*nn+2)+(ones(nn,1)-ass).*qs);

%ceq: additional equality constraints for private/assignable goods
k=2;
for i=1:nn
    if ass(i)==1
        k=k+1;
        c(k)= qr(i)-(x4(2*nn+2+i)+x4(3*nn+2+i));
        k=k+1;
        c(k)= qs(i)-(x4(4*nn+2+i)+x4(5*nn+2+i));
        if excl1(i)==1
            k=k+1;
            c(k)= qr(i)-x4(2*nn+2+i);
            k=k+1;
            c(k)= qs(i)- x4(4*nn+2+i);
        end
        if excl2(i)==1            
            k=k+1;
            c(k)= qr(i)-x4(3*nn+2+i);
            k=k+1;
            c(k)= qs(i)-x4(5*nn+2+i);
        end
    end    
end

% c: 2 inequality constraints on double sums
c(2+2*numbass+2*numbexcl+1)=(pr'*qe - pr'*(excl2.*qe))-pr'*(excl1.*qr);
c(2+2*numbass+2*numbexcl+2)=(ps'*qe - ps'*(excl1.*qe))-ps'*(excl2.*qs);


% c: inequality constraint that say upper bound above lower bound and upper bound below expenditure
 c(2+2*numbass+2*numbexcl+3)=pe'*qe-x4(6*nn+3)-x4(6*nn+4);
 c(2+2*numbass+2*numbexcl+4)=-(pe'*qe)+x4(6*nn+3);
 c(2+2*numbass+2*numbexcl+5)=-(pe'*qe)+x4(6*nn+4);


%lower bounds on expenditure shares
c(2+2*numbass+2*numbexcl+6)=-x4(6*nn+3);
c(2+2*numbass+2*numbexcl+7)=-x4(6*nn+4);

% c: further inequality constraints to obtain positive (personalized) quantities for qr and qs
k=2+2*numbass+2*numbexcl+8;
for i=2*nn+3:6*nn+2
c(k)=-x4(i);
k=k+1;
end
for i=1:nn
c(k)=-qs(i);
k=k+1;
c(k)=-qr(i);
k=k+1;
end