function c = PNPOPTPARAMconst_ass3SHrestr_tomrun(x3)

global qe pe ass excl1 excl2 X nn  numbass numbexcl rows3_constraints

% Calculation household demand r (= 1 in paper) and s (= 2 in paper)

p1=x3(1:nn);
ex1=x3(nn+1);

p2=x3(nn+2:2*nn+1);
ex2=x3(2*nn+2);

qr=zeros(nn,1);
qr=QUAIDSSR1(p1,ex1);

qs=zeros(nn,1);
qs=QUAIDSSR1(p2,ex2);

pr=x3(1:nn);
ps=x3(nn+2:2*nn+1);

c=zeros(rows3_constraints,1);

%ceq: first 2 equality constraints for defining the upper bounds
c(1)=x3(6*nn+3)-pe'*(ass.*x3(2*nn+3:3*nn+2)+(ones(nn,1)-ass).*qr);
c(2)=x3(6*nn+4)-pe'*(ass.*x3(5*nn+3:6*nn+2)+(ones(nn,1)-ass).*qs);

%ceq: additional equality constraints for private/assignable goods
k=2;
for i=1:nn
    if ass(i)==1
        k=k+1;
        c(k)= qr(i)-(x3(2*nn+2+i)+x3(3*nn+2+i));
        k=k+1;
        c(k)= qs(i)-(x3(4*nn+2+i)+x3(5*nn+2+i));
        if excl1(i)==1
            k=k+1;
            c(k)= qr(i)-x3(2*nn+2+i);
            k=k+1;
            c(k)= qs(i)- x3(4*nn+2+i);
        end
        if excl2(i)==1            
            k=k+1;
            c(k)= qr(i)-x3(3*nn+2+i);
            k=k+1;
            c(k)= qs(i)-x3(5*nn+2+i);
        end
    end    
end

% c: 2 inequality constraints on double sums
c(2+2*numbass+2*numbexcl+1)=ps'*(qe+qr)-ps'*qs;
c(2+2*numbass+2*numbexcl+2)=(pr'*qs - pr'*(excl2.*qs))-pr'*(excl1.*qr);
c(2+2*numbass+2*numbexcl+3)=(pr'*qe - pr'*(excl2.*qe))-pr'*(excl1.*qr);

% c: inequality constraint that say upper bound above lower bound and upper bound below expenditure
 c(2+2*numbass+2*numbexcl+4)=pe'*qe-x3(6*nn+3)-x3(6*nn+4);
 c(2+2*numbass+2*numbexcl+5)=-(pe'*qe)+x3(6*nn+3);
 c(2+2*numbass+2*numbexcl+6)=-(pe'*qe)+x3(6*nn+4);
 
%lower bounds on expenditure shares
c(2+2*numbass+2*numbexcl+7)=-x3(6*nn+3);
c(2+2*numbass+2*numbexcl+8)=-x3(6*nn+4);

% c: further inequality constraints to obtain positive (personalized) quantities for qr and qs
k=2+2*numbass+2*numbexcl+9;
for i=2*nn+3:6*nn+2
c(k)=-x3(i);
k=k+1;
end
for i=1:nn
c(k)=-qs(i);
k=k+1;
c(k)=-qr(i);
k=k+1;
end
